package cn.ysk.cashier.cons.service.impl;

import cn.ysk.cashier.cons.domain.TbConsSuppFlow;
import cn.ysk.cashier.utils.FileUtil;
import cn.ysk.cashier.utils.PageUtil;
import cn.ysk.cashier.utils.QueryHelp;
import cn.ysk.cashier.utils.ValidationUtil;
import lombok.RequiredArgsConstructor;
import cn.ysk.cashier.cons.repository.TbConsSuppFlowRepository;
import cn.ysk.cashier.cons.service.TbConsSuppFlowService;
import cn.ysk.cashier.cons.service.dto.TbConsSuppFlowDto;
import cn.ysk.cashier.cons.service.dto.TbConsSuppFlowQueryCriteria;
import cn.ysk.cashier.cons.service.mapstruct.TbConsSuppFlowMapper;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.LinkedHashMap;

/**
* @website https://eladmin.vip
* @description 服务实现
* @author admin
* @date 2024-07-02
**/
@Service
@RequiredArgsConstructor
public class TbConsSuppFlowServiceImpl implements TbConsSuppFlowService {

    private final TbConsSuppFlowRepository tbConsSuppFlowRepository;
    private final TbConsSuppFlowMapper tbConsSuppFlowMapper;

    @Override
    public Map<String,Object> queryAll(TbConsSuppFlowQueryCriteria criteria, Pageable pageable){
        Page<TbConsSuppFlow> page = tbConsSuppFlowRepository.findAll((root, criteriaQuery, criteriaBuilder) -> QueryHelp.getPredicate(root,criteria,criteriaBuilder),pageable);
        return PageUtil.toPage(page.map(tbConsSuppFlowMapper::toDto));
    }

    @Override
    public List<TbConsSuppFlowDto> queryAll(TbConsSuppFlowQueryCriteria criteria){
        return tbConsSuppFlowMapper.toDto(tbConsSuppFlowRepository.findAll((root, criteriaQuery, criteriaBuilder) -> QueryHelp.getPredicate(root,criteria,criteriaBuilder)));
    }

    @Override
    @Transactional
    public TbConsSuppFlowDto findById(Integer id) {
        TbConsSuppFlow tbConsSuppFlow = tbConsSuppFlowRepository.findById(id).orElseGet(TbConsSuppFlow::new);
        ValidationUtil.isNull(tbConsSuppFlow.getId(),"TbConsSuppFlow","id",id);
        return tbConsSuppFlowMapper.toDto(tbConsSuppFlow);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public TbConsSuppFlowDto create(TbConsSuppFlow resources) {
        return tbConsSuppFlowMapper.toDto(tbConsSuppFlowRepository.save(resources));
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void update(TbConsSuppFlow resources) {
        TbConsSuppFlow tbConsSuppFlow = tbConsSuppFlowRepository.findById(resources.getId()).orElseGet(TbConsSuppFlow::new);
        ValidationUtil.isNull( tbConsSuppFlow.getId(),"TbConsSuppFlow","id",resources.getId());
        tbConsSuppFlow.copy(resources);
        tbConsSuppFlowRepository.save(tbConsSuppFlow);
    }

    @Override
    public void deleteAll(Integer[] ids) {
        for (Integer id : ids) {
            tbConsSuppFlowRepository.deleteById(id);
        }
    }

    @Override
    public void download(List<TbConsSuppFlowDto> all, HttpServletResponse response) throws IOException {
        List<Map<String, Object>> list = new ArrayList<>();
        for (TbConsSuppFlowDto tbConsSuppFlow : all) {
            Map<String,Object> map = new LinkedHashMap<>();
            map.put(" conInfoId",  tbConsSuppFlow.getConInfoId());
            map.put("店铺id", tbConsSuppFlow.getShopId());
            map.put(" skuId",  tbConsSuppFlow.getSkuId());
            map.put(" productId",  tbConsSuppFlow.getProductId());
            map.put(" supplierId",  tbConsSuppFlow.getSupplierId());
            map.put("出入库类型: in 入库 out 出库", tbConsSuppFlow.getType());
            map.put("数量", tbConsSuppFlow.getStockNumber());
            map.put("进价", tbConsSuppFlow.getPrice());
            map.put("小计", tbConsSuppFlow.getAmount());
            map.put("剩余库存", tbConsSuppFlow.getBalance());
            map.put("应付款", tbConsSuppFlow.getAccountsPayable());
            map.put("实付款", tbConsSuppFlow.getActualPayment());
            map.put(" paymentTime",  tbConsSuppFlow.getPaymentTime());
            map.put(" createTime",  tbConsSuppFlow.getCreateTime());
            map.put(" updateTime",  tbConsSuppFlow.getUpdateTime());
            list.add(map);
        }
        FileUtil.downloadExcel(list, response);
    }
}